#include "Base64.h"

const char *BASE64::szB64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

BASE64::BASE64() : m_lpszOutput(NULL)
{
	m_nLen = 0;
}
BASE64::~BASE64()
{
	if(m_lpszOutput) {
		delete [] m_lpszOutput;
	}
}

const char *BASE64::Encode(const char *szStr, int nLens)
{
	if(m_lpszOutput) {
		delete [] m_lpszOutput;
	}
	if(nLens == -1)
		m_nLen = (unsigned int)strlen(szStr);
	else
		m_nLen = nLens;

	m_lpszOutput = new char[(int)((double)(m_nLen)*1.5) + 32];
	memset(m_lpszOutput, 0x00, ( (int)((double)(m_nLen)*1.5) + 32 ));


	unsigned long i,j;
	for(i = 0,j = 0; i < (m_nLen - (m_nLen % 3)); i+=3)
	{
		// 1
		m_lpszOutput[j]		= szB64[(szStr[i] & 0xfc) >> 2];		//  擪 6byte	(ooooooxx)

		// 2
		m_lpszOutput[j+1]	= szB64[((szStr[i] &0x03) << 4) | 		//   2byte	(xxxxxxoo)
									((szStr[i+1] & 0xf0) >> 4)];	// +擪 4byte	(ooooxxxx)

		// 3
		m_lpszOutput[j+2]	= szB64[((szStr[i+1] & 0x0f) << 2 ) |	//   4byte	(xxxxoooo)
									((szStr[i+2] & 0xc0) >> 6)];	// +擪 2byte	(ooxxxxxx)

		// 4
		m_lpszOutput[j+3]	= szB64[(szStr[i+2] & 0x3f)];			//   6byte	(xxoooooo)
		j += 4;
	}

	i = m_nLen - (m_nLen % 3);	// c̃TCYvZ
	switch(m_nLen % 3)
	{
		case 2:	// 1pfBOKv
		{
			m_lpszOutput[j]		= szB64[(szStr[i] & 0xfc) >> 2];		//  擪 6byte	(ooooooxx)

			m_lpszOutput[j+1]	= szB64[((szStr[i] &0x03) << 4) |		//   2byte	(xxxxxxoo)
										((szStr[i+1] & 0xf0) >> 4)];	// +擪 4byte	(oooox

			m_lpszOutput[j+2]	= szB64[((szStr[i+1] & 0x0f) <<2 )];	//   4byte	(xxxxoooo)
			m_lpszOutput[j+3]	= szB64[64];							//  "="Ŗ߂
			m_lpszOutput[j+4]	= '\0';
		}
		break;

		case 1:	// 2pfBOKv
		{
			m_lpszOutput[j]		= szB64[(szStr[i] & 0xfc) >> 2];		//  擪 6byte	(ooooooxx)

			m_lpszOutput[j+1]	= szB64[((szStr[i] &0x03) << 4)];		//   2byte	(xxxxxxoo)
			m_lpszOutput[j+2]	= szB64[64];							//  "="Ŗ߂

			m_lpszOutput[j+3]	= szB64[64];							//  "="Ŗ߂
			m_lpszOutput[j+4]	= '\0';
		}
			break;
	}
	m_lpszOutput[j+4] = '\0';
	return m_lpszOutput;
}

const char *BASE64::Decode(const char *szStr)
{
	//lpszOutputString
	unsigned long i, j, l,iWriteCount,len;
	len = m_nLen = (unsigned int)strlen(szStr);
	if(m_lpszOutput) {
		delete [] m_lpszOutput;
	}
	m_nLen = (int)(((double)(m_nLen)/4.0)*3.0) + 4;
	m_lpszOutput = new char[m_nLen];

	char c;
	char buf[4];
	for(i = 0, j = 0; i < len; i+=4)
	{
		iWriteCount = 3;
		for(l = 0; l < 4 && i+l<len; l++)
		{
			c = szStr[i+l];
			if(c == szB64[64]) {	// Pad
				iWriteCount--;
			} else {
				buf[l] = FindIndexInB64(c);
			}
		}
		m_lpszOutput[j] = ((buf[0] << 2) & 0xfc) | ((buf[1] >> 4) & 0x03);

		if(iWriteCount >= 2)
			m_lpszOutput[j+1] = ((buf[1] << 4) & 0xf0) | ((buf[2] >> 2) & 0x0f);

		if(iWriteCount == 3)		
			m_lpszOutput[j+2] = ((buf[2] << 6) & 0xc0) | (buf[3] & 0x3f);

		j+=iWriteCount;
	}
	m_nLen = j;
	m_lpszOutput[j] = '\0';

	return m_lpszOutput;
}



int BASE64::FindIndexInB64(char c)
{
	int index = 0;
	while(szB64[index] != '\0' && szB64[index] != c) {
		index++;
	}
	if (szB64[index] == '\0') {
		return -1;	// 炸
	}
	return index;	// B
}
